<?php
/**
 * Pmclain_Stripe extension
 * NOTICE OF LICENSE
 *
 * This source file is subject to the OSL 3.0 License
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * https://opensource.org/licenses/osl-3.0.php
 *
 * @category  Pmclain
 * @package   Pmclain_Stripe
 * @copyright Copyright (c) 2017-2018
 * @license   Open Software License (OSL 3.0)
 */
namespace Pmclain\Stripe\Test\Unit\Gateway\Http\Client;

use Pmclain\Stripe\Gateway\Http\TransferFactory;
use Magento\Payment\Gateway\Http\TransferBuilder;
use Magento\Payment\Gateway\Http\TransferInterface;

class TransferFactoryTest extends \PHPUnit\Framework\TestCase
{
  /**
   * @var TransferFactory
   */
  private $transferFactory;

  /**
   * @var TransferFactory
   */
  private $transferMock;

  /**
   * @var TransferBuilder|\PHPUnit_Framework_MockObject_MockObject
   */
  private $transferBuilder;

  protected function setUp() {
    $this->transferBuilder = $this->createMock(TransferBuilder::class);
    $this->transferMock = $this->createMock(TransferInterface::class);

    $this->transferFactory = new TransferFactory($this->transferBuilder);
  }

  public function testCreate() {
    $request = ['data1', 'data1'];

    $this->transferBuilder->expects($this->once())
      ->method('setBody')
      ->with($request)
      ->willReturnSelf();

    $this->transferBuilder->expects($this->once())
      ->method('build')
      ->willReturn($this->transferMock);

    $this->assertEquals($this->transferMock, $this->transferFactory->create($request));
  }
}